Subject: Re: bug#64270: 30.0.50; Font update for no toolkit menu

From: Robert Pluim <[email-masked]>
Date: Tue, 27 Jun 2023 11:42:19 +0200

>>>>> On Tue, 27 Jun 2023 16:55:39 +0800, Po Lu <[email-masked]> said:

    Po Lu> Robert Pluim <[email-masked]> writes:
    >>>>>>> On Tue, 27 Jun 2023 10:37:30 +0200, Robert Pluim <[email-masked]> said:
    >> 
    >>>>>>> On Tue, 27 Jun 2023 15:48:29 +0800, Po Lu via "Bug reports for GNU Emacs, the Swiss army knife of text editors" <[email-masked]> said:
    >> >>> Ah then I have a bug in Emacs' XLFD generation on my system.  Here is
    >> >>> what I get with 'C-u C-x =':
    >> >>> 
    >> >>> ftcrhb:-Misc-Fixed-regular-normal-normal-*-18-*-*-*-c-90-iso10646-1 (#x59)
    >> 
    Robert> Po Lu> ``XLFD'' strings generated by Emacs aren't guaranteed to be
    Robert> Po Lu> X11-compatible; Emacs is only designed to read them.  I don't remember
    Robert> Po Lu> whether or not this is intentional, so you will have to ask Kenichi
    Robert> Po Lu> Handa, but I have a sinking suspicion that he is not around anymore...
    Robert> For at least 15 years prior to Larsʼ changes to support 'medium'
    Robert> fonts, that would have returned
    Robert> ftcrhb:-Misc-Fixed-medium-normal-normal-*-18-*-*-*-c-90-iso10646-1 (#x59)
    >> 
    >> I mean:
    >> 
    >> ftcrhb:-Misc-Fixed-normal-normal-normal-*-18-*-*-*-c-90-iso10646-1 (#x59)
    >> 
    >> Robert

    Po Lu> Right, but the problem is different: X doesn't support medium at all,
    Po Lu> but calls Emacs's `normal' `medium'.  Here are all the valid values for
    Po Lu> an XLFD:

    Po Lu> 0	Undefined
    Po Lu> 10	UltraLight
    Po Lu> 20	ExtraLight	 
    Po Lu> 30	Light	 
    Po Lu> 40	SemiLight
    Po Lu> 50	Medium
    Po Lu> 60	SemiBold
    Po Lu> 70	Bold	 
    Po Lu> 80	ExtraBold
    Po Lu> 90	UltraBold

OK, but we could still fix this niggle in `font_unparse_xlfd' (if I
call it a regression, can it go in emacs-29? 😸)

Robert
--